# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
from . import _utilities

__all__ = ['InterrogationServicesArgs', 'InterrogationServices']

@pulumi.input_type
class InterrogationServicesArgs:
    def __init__(__self__, *,
                 vulnerability_scan_policy: pulumi.Input[str],
                 default_scanner: Optional[pulumi.Input[str]] = None):
        """
        The set of arguments for constructing a InterrogationServices resource.
        :param pulumi.Input[str] vulnerability_scan_policy: The frequency of the vulnerability scanning is done. This can be `Daily`, `Weekly`, `Monthly` or can be a custom cron string.
        :param pulumi.Input[str] default_scanner: Sets the default interrogation service **Clair**
        """
        pulumi.set(__self__, "vulnerability_scan_policy", vulnerability_scan_policy)
        if default_scanner is not None:
            pulumi.set(__self__, "default_scanner", default_scanner)

    @property
    @pulumi.getter(name="vulnerabilityScanPolicy")
    def vulnerability_scan_policy(self) -> pulumi.Input[str]:
        """
        The frequency of the vulnerability scanning is done. This can be `Daily`, `Weekly`, `Monthly` or can be a custom cron string.
        """
        return pulumi.get(self, "vulnerability_scan_policy")

    @vulnerability_scan_policy.setter
    def vulnerability_scan_policy(self, value: pulumi.Input[str]):
        pulumi.set(self, "vulnerability_scan_policy", value)

    @property
    @pulumi.getter(name="defaultScanner")
    def default_scanner(self) -> Optional[pulumi.Input[str]]:
        """
        Sets the default interrogation service **Clair**
        """
        return pulumi.get(self, "default_scanner")

    @default_scanner.setter
    def default_scanner(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "default_scanner", value)


@pulumi.input_type
class _InterrogationServicesState:
    def __init__(__self__, *,
                 default_scanner: Optional[pulumi.Input[str]] = None,
                 vulnerability_scan_policy: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering InterrogationServices resources.
        :param pulumi.Input[str] default_scanner: Sets the default interrogation service **Clair**
        :param pulumi.Input[str] vulnerability_scan_policy: The frequency of the vulnerability scanning is done. This can be `Daily`, `Weekly`, `Monthly` or can be a custom cron string.
        """
        if default_scanner is not None:
            pulumi.set(__self__, "default_scanner", default_scanner)
        if vulnerability_scan_policy is not None:
            pulumi.set(__self__, "vulnerability_scan_policy", vulnerability_scan_policy)

    @property
    @pulumi.getter(name="defaultScanner")
    def default_scanner(self) -> Optional[pulumi.Input[str]]:
        """
        Sets the default interrogation service **Clair**
        """
        return pulumi.get(self, "default_scanner")

    @default_scanner.setter
    def default_scanner(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "default_scanner", value)

    @property
    @pulumi.getter(name="vulnerabilityScanPolicy")
    def vulnerability_scan_policy(self) -> Optional[pulumi.Input[str]]:
        """
        The frequency of the vulnerability scanning is done. This can be `Daily`, `Weekly`, `Monthly` or can be a custom cron string.
        """
        return pulumi.get(self, "vulnerability_scan_policy")

    @vulnerability_scan_policy.setter
    def vulnerability_scan_policy(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "vulnerability_scan_policy", value)


class InterrogationServices(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 default_scanner: Optional[pulumi.Input[str]] = None,
                 vulnerability_scan_policy: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        """
        ## Example Usage

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] default_scanner: Sets the default interrogation service **Clair**
        :param pulumi.Input[str] vulnerability_scan_policy: The frequency of the vulnerability scanning is done. This can be `Daily`, `Weekly`, `Monthly` or can be a custom cron string.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: InterrogationServicesArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        ## Example Usage

        :param str resource_name: The name of the resource.
        :param InterrogationServicesArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(InterrogationServicesArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 default_scanner: Optional[pulumi.Input[str]] = None,
                 vulnerability_scan_policy: Optional[pulumi.Input[str]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = InterrogationServicesArgs.__new__(InterrogationServicesArgs)

            __props__.__dict__["default_scanner"] = default_scanner
            if vulnerability_scan_policy is None and not opts.urn:
                raise TypeError("Missing required property 'vulnerability_scan_policy'")
            __props__.__dict__["vulnerability_scan_policy"] = vulnerability_scan_policy
        super(InterrogationServices, __self__).__init__(
            'harbor:index/interrogationServices:InterrogationServices',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            default_scanner: Optional[pulumi.Input[str]] = None,
            vulnerability_scan_policy: Optional[pulumi.Input[str]] = None) -> 'InterrogationServices':
        """
        Get an existing InterrogationServices resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] default_scanner: Sets the default interrogation service **Clair**
        :param pulumi.Input[str] vulnerability_scan_policy: The frequency of the vulnerability scanning is done. This can be `Daily`, `Weekly`, `Monthly` or can be a custom cron string.
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _InterrogationServicesState.__new__(_InterrogationServicesState)

        __props__.__dict__["default_scanner"] = default_scanner
        __props__.__dict__["vulnerability_scan_policy"] = vulnerability_scan_policy
        return InterrogationServices(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="defaultScanner")
    def default_scanner(self) -> pulumi.Output[Optional[str]]:
        """
        Sets the default interrogation service **Clair**
        """
        return pulumi.get(self, "default_scanner")

    @property
    @pulumi.getter(name="vulnerabilityScanPolicy")
    def vulnerability_scan_policy(self) -> pulumi.Output[str]:
        """
        The frequency of the vulnerability scanning is done. This can be `Daily`, `Weekly`, `Monthly` or can be a custom cron string.
        """
        return pulumi.get(self, "vulnerability_scan_policy")

